
#include <math.h>
#include <string.h>
#include <stdio.h>
#include <malloc.h>

#undef NDEBUG
#include <assert.h>

#ifndef INCLUDEUCHAR
#ifndef uchar
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define ushort  unsigned short
#endif
#endif

static void init (void);
static void cleanup (void);
static void about (void);
static void configure (void);

// Functions exported from the C++ part of the program
// where the actual freeverb code is located.





extern void do_reverb (float *, float *, float *, float *, long);
extern void set_reverb_params (float, float, float, float, float, float);



float *buffer_in_left = NULL;
float *buffer_in_right = NULL;
float *buffer_out_left = NULL;
float *buffer_out_right = NULL;

float attenuation = 0.65;

int conf_stuff_created = 0;



int notyet = 0;

void
freeverbinit (void)
{
	notyet = 1;
	if (buffer_in_left)
	  {
		  free (buffer_in_left);
		  buffer_in_left = NULL;
	  }

	if (buffer_in_right)
	  {
		  free (buffer_in_right);
		  buffer_in_right = NULL;
	  }

	if (buffer_out_left)
	  {
		  free (buffer_out_left);
		  buffer_out_left = NULL;
	  }

	if (buffer_out_right)
	  {
		  free (buffer_out_right);
		  buffer_out_right = NULL;
	  }



	//roomsize_adjustment = 0.50;//gtk_adjustment_new(0.50, 0.0, 1.0, 0.05, 0.1, 0);

	/*damp_adjustment = gtk_adjustment_new(0.50, 0.0, 1.0, 0.05, 0.1, 0);
	   wet_adjustment = gtk_adjustment_new(0.25, 0.0, 1.0, 0.05, 0.1, 0);
	   dry_adjustment = gtk_adjustment_new(0.95, 0.0, 1.0, 0.05, 0.1, 0);
	   width_adjustment = gtk_adjustment_new(1.00, 0.0, 1.0, 0.05, 0.1, 0);
	   atten_adjustment = gtk_adjustment_new(0.65, 0.0, 1.0, 0.05, 0.1, 0);
	 */
}


//lenght = bytes
int
freeverb (char *d, int length, int srate, int nch, int bits, int channels)
{
	int i;
	int no_samples = length >> 2;
	short *data = (short *) d;
	short *ptr;
	float f;



	if (16 != bits)
	  {

		  return length;
	  }

	if (2 != channels)
	  {

		  return length;

	  }
	// Allocate float sample buffers if this hasn't already been done.
	if (buffer_in_left == NULL)
	  {
		  i = sizeof (float) * no_samples;
		  buffer_in_left = (float *) malloc (i);
		  buffer_in_right = (float *) malloc (i);
		  buffer_out_left = (float *) malloc (i);
		  buffer_out_right = (float *) malloc (i);
	  }


	// Copy data into float input buffer.
	for (i = 0; i < no_samples; i++)
	  {
		  buffer_in_left[i] = ((float) data[i << 1]) * attenuation;
		  buffer_in_right[i] =
			  ((float) data[(i << 1) + 1]) * attenuation;
	  }






	if (notyet)
	  {
		  int i;
		  int b;

float *left = NULL;
float *right = NULL;
float *out_left = NULL;
float *out_right = NULL;


		  i = sizeof (float) * no_samples;
		  left = (float *) malloc (i);
		  right = (float *) malloc (i);
		  out_left = (float *) malloc (i);
		  out_right = (float *) malloc (i);

		  for (b = 0; b < no_samples; b++)
		    {

			    left[b] = 0.0;
			    right[b] = 0.0;
			    out_left[b] = 0.0;
			    out_right[b] = 0.0;

		    }



		  do_reverb (left, right, out_left, out_right, no_samples);


	for (b = 0; b < no_samples; b++)
		    {

			    left[b] = 0.0;
			    right[b] = 0.0;
			    out_left[b] = 0.0;
			    out_right[b] = 0.0;

		    }



		  do_reverb (left, right, out_left, out_right, no_samples);


		  for (b = 0; b < no_samples; b++)
		    {

			    left[b] = 0.0;
			    right[b] = 0.0;
			    out_left[b] = 0.0;
			    out_right[b] = 0.0;

		    }



		  do_reverb (left, right, out_left, out_right, no_samples);


		  for (b = 0; b < no_samples; b++)
		    {

			    left[b] = 0.0;
			    right[b] = 0.0;
			    out_left[b] = 0.0;
			    out_right[b] = 0.0;

		    }



		  do_reverb (left, right, out_left, out_right, no_samples);



			  free(  left);
			  free(  right);
			  free(  out_left);
			   free( out_right);

		  notyet = 0;
	  }







	do_reverb (buffer_in_left, buffer_in_right,
		   buffer_out_left, buffer_out_right, no_samples);

	// Extract data from float output buffer.
	for (i = 0; i < no_samples; i++)
	  {
		  // Clip to max/min value if overflow/underflow occurs
		  // to reduce audible artifacts resulting from values outside
		  // representable range.

		  f = buffer_out_left[i];
		  if (f > 32767.0)
			  data[i << 1] = 32767;
		  else if (f < -32768.0)
			  data[i << 1] = -32768;
		  else
			  data[i << 1] = f;
		  f = buffer_out_right[i];
		  if (f > 32767.0)
			  data[(i << 1) + 1] = 32767;
		  else if (f < -32768.0)
			  data[(i << 1) + 1] = -32768;
		  else
			  data[(i << 1) + 1] = f;
	  }
//assert(0);
	return length;
}
